/*
This program has been developed by students from the bachelor Computer Science at Utrecht University within the Software Project course.
© Copyright Utrecht University (Department of Information and Computing Sciences)
*/

package consume

import (
	"encoding/json"
	"query-service/internal/entity"
	"query-service/pkg/errorhandler"
)

/*
This publishes the status
	status: string, the status to be published,
	sessionID: *string, the ID of the session
	queryID: *string, the ID of the query
*/
func (s *Service) publishStatus(status string, sessionID *string, queryID *string) {
	msg := entity.StatusMessageStruct{
		Type: "query_status_update",
		Value: entity.Status{
			Status:  status,
			QueryID: *queryID,
		},
	}

	msgBytes, err := json.Marshal(msg)
	if err != nil {
		errorhandler.FailWithError(err, "Marshalling status update message went wrong")
		return
	}

	s.producer.PublishMessage(&msgBytes, sessionID)
}
